#ifndef _PARALLELS_H_
#define _PARALLELS_H_

#include <element.h>

#include <addon.h>
#include <table.h>
#include <part.h>
#include <track.h>

class PrPartEditor;
class QPainter;

class Parallels : public Addon
{

  friend class Track;

 private:
  void add(const char *, long, int, int, int, int, int);
  Track * _track;
  Part * _part;
  
  int WEAK_PARALLEL;
  int STRONG_PARALLEL;
  int INTERVAL_SIZE;

 public:
  /** The constructor is given a parameter specifying the target of the operation
   * implement this typically for a Song, Track, Part and NULL, where NULL indicates that
   * the globally defined table * selectioN is used as a target
   */
  Parallels(Element*);
  ~Parallels();

  virtual void song(Song*);
  
  void undo();
  void redo();

  virtual void setMarks(PrPartEditor * ed);
  virtual void mark(Event * ev, int x, int y);


};

#endif
