#ifndef _REVERT_CPP_
#define _REVERT_CPP_

#include <iostream.h>
#include <string.h>

#include <reference.h>
#include <table.h>
#include <event.h>
#include <part.h>
#include <track.h>
#include <scoreTrack.h>
#include <song.h>
#include <str.h>
#include <iterator.h>
#include <selectionIterator.h>
#include <songIterator.h>
#include <note.h>
#include <masterEvent.h>
#include <midiEvent.h>
#include <audioEvent.h>
#include <symbol.h>

#include "revert.h"

extern Table * selectioN;
extern Table * selectionMemory;

// #define REVERT_CONTEXT Addon::TREAT_SELECTION + Addon::TREAT_TRACK + Addon::TREAT_PART + Addon::TREAT_SONG


extern "C" {
  Addon * revert(Element * target) { return new Revert(target); }
  const char  * revert_name()     { return "revert"; }             // the name to be used to list this operation
  const char  * revert_category() { return "edit"; }               // the category to be listed
  int     revert_context() { return Addon::TREAT_SONG; }              // the context
}

/** To initialize the addon, use the following parameters:
    1. char * name      - the name of the operation
    2. Element * target - the target (just use the parameter from the Operations contructor)
    3. bool undoable    - use TO_BE_UNDONE or !TO_BE_UNDONE, depending on whether the operation shall be undoable or not
    4. int context      - just use the above defined context here
*/

Revert::Revert(Element * target) : Addon("revert element", target, !TO_BE_UNDONE, Addon::TREAT_SONG) { run(); }

Revert::~Revert() {

}


/**
 ** implement your action on the song here
 **/
void Revert::song(Song * song) {
  Position endpos = (new SongIterator(song))->endPosition();
  int sz = song->size();
  for (int i=0; i<sz; i++) {
    Track * track = (Track *) song->get(0); if (track==0) return;
    Part * part   = (Part *) track->first(); if (part==0) return;
    Track * newTrack = song->createTrack(track->isA(),0);
    newTrack->setName(strdup(track->name()->getValue()));
    if (track->isA()==SCORETRACK) {
      ((ScoreTrack*) newTrack)->setProgram(track->program());
      ((ScoreTrack*) newTrack)->setChannel(track->channel());
    }
    Part * newPart = new Part(newTrack);
    newPart->setKey(part->key()); newPart->setClef(part->clef());
    newTrack->add(newPart); song->add(newTrack);
    for (Iterator i = Iterator(track); !i.done(); i++) {
      Event * event = (Event*) (*i)->copy();
      newPart->setStart(event, endpos - i.part()->end(event));
      newPart->add(event);
    }
    song->remove(track); delete track;
  }
}

void Revert::undo() {
}

void Revert::redo() {
}






#endif
